VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WaveEncoder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' WAV Encoder mits ACM Codec Untersttzung

Private Declare Sub CpyMem Lib "kernel32" _
Alias "RtlMoveMemory" ( _
    pDst As Any, pSrc As Any, ByVal dwLen As Long _
)

Private Declare Sub ZeroMem Lib "kernel32" _
Alias "RtlZeroMemory" ( _
    pDst As Any, ByVal dwLen As Long _
)

Private Declare Function IsBadReadPtr Lib "kernel32" ( _
    ptr As Any, ByVal ucb As Long _
) As Long

Private Declare Function IsBadWritePtr Lib "kernel32" ( _
    ptr As Any, ByVal ucb As Long _
) As Long

Private Declare Function CreateFile Lib "kernel32.dll" _
Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long _
) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, _
    ByVal lpOverlapped As Any _
) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
    ByVal hFile As Long, lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, _
    ByVal lpOverlapped As Any _
) As Long

Private Declare Function SetFilePointer Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal lDistanceToMove As Long, ByVal lpDistanceToMoveHigh As Long, _
    ByVal dwMoveMethod As Long _
) As Long

Private Declare Function GetFileSize Lib "kernel32" ( _
    ByVal hFile As Long, ByVal lpFileSizeHigh As Long _
) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long _
) As Long

Private Declare Function acmStreamPrepareHeader Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, ByVal fdwPrepare As Long _
) As Long

Private Declare Function acmStreamUnprepareHeader Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, ByVal fdwUnprepare As Long _
) As Long

Private Declare Function acmStreamOpen Lib "msacm32" ( _
    phas As Long, _
    ByVal had As Long, _
    pwfxSrc As Any, pwfxDst As Any, _
    ByVal pwfltr As Long, _
    ByVal dwCallback As Long, ByVal dwInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Private Declare Function acmStreamSize Lib "msacm32" ( _
    ByVal has As Long, ByVal cbInput As Long, _
    pdwOutputBytes As Long, ByVal fdwSize As Long _
) As Long

Private Declare Function acmStreamConvert Lib "msacm32" ( _
    ByVal has As Long, pash As ACMSTREAMHEADER, ByVal fdwConvert As Long _
) As Long

Private Declare Function acmStreamReset Lib "msacm32" ( _
    ByVal has As Long, ByVal fdwReset As Long _
) As Long

Private Declare Function acmStreamClose Lib "msacm32" ( _
    ByVal has As Long, ByVal fdwClose As Long _
) As Long

Private Declare Function acmFormatChoose Lib "msacm32" _
Alias "acmFormatChooseA" ( _
    pfmtc As ACMFORMATCHOOSEA _
) As Long

Public Enum SND_RESULT
    SND_ERR_SUCCESS = 0
    SND_ERR_INVALID_SOURCE
    SND_ERR_INVALID_OUTPUT
    SND_ERR_INTERNAL
    SND_ERR_OUT_OF_RANGE
    SND_ERR_END_OF_STREAM
    SND_ERR_INVALID_TAG
    SND_ERR_INVALID_PARAM
    SND_ERR_TOO_BIG
    SND_ERR_NEED_MORE
    SND_ERR_WRITE_ERROR
    SND_ERR_UNKNOWN
End Enum

Public Enum ENCODER_METRICS
    ENC_M_PCM_PER_DELIVERY_MIN = 0
    ENC_M_PCM_PER_DELIVERY_MAX
    ENC_M_SUPPORT_TAGS
End Enum

Private Enum FILE_OPEN_METHOD
    CREATE_NEW = 1
    CREATE_ALWAYS = 2
    OPEN_EXISTING = 3
    OPEN_ALWAYS = 4
End Enum

Private Enum FILE_SHARE_RIGHTS
    FILE_SHARE_READ = &H1
    FILE_SHARE_WRITE = &H2
End Enum

Private Enum FILE_ACCESS_RIGHTS
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Private Enum SEEK_METHOD
    FILE_BEGIN = 0
    FILE_CURRENT = 1
    FILE_END = 2
End Enum

Private Enum HACMSTREAM
    INVALID_STREAM_HANDLE = 0
End Enum

Private Enum ACM_STREAMSIZEF
    ACM_STREAMSIZEF_DESTINATION = &H1
    ACM_STREAMSIZEF_SOURCE = &H0
    ACM_STREAMSIZEF_QUERYMASK = &HF
End Enum

Private Enum ACM_STREAMCONVERTF
    ACM_STREAMCONVERTF_BLOCKALIGN = &H4
    ACM_STREAMCONVERTF_START = &H10
    ACM_STREAMCONVERTF_END = &H20
End Enum

Private Const INVALID_HANDLE                As Long = -1

Private Const ACMFMTDET_FORMAT_CHARS        As Long = 128
Private Const ACMFMTTAGDET_FORMATTAG_CHARS  As Long = 48

Private Const ACM_FORMATENUMF_CONVERT       As Long = &H100000

Private Const WAVE_FORMAT_PCM               As Long = 1

Private Const WFXSize                       As Long = 128& * 1024&

Private Const WAV_RIFF                      As Long = 1179011410
Private Const WAV_WAVE                      As Long = 1163280727
Private Const WAV_DATA                      As Long = 1635017060
Private Const WAV_FMT                       As Long = 544501094

Private Type hFile
    handle                                  As Long
    path                                    As String
End Type

Private Type ACMSTREAMHEADER
    cbStruct                                As Long
    fdwStatus                               As Long
    dwUser                                  As Long
    pbSrc                                   As Long
    cbSrcLength                             As Long
    cbSrcLengthUsed                         As Long
    dwSrcUser                               As Long
    pbDst                                   As Long
    cbDstLength                             As Long
    cbDstLengthUsed                         As Long
    dwDstUser                               As Long
    dwReservedDriver(9)                     As Long
End Type

Private Type ACMFORMATCHOOSEA
    cbStruct                                As Long
    fdwStyle                                As Long
    hwndOwner                               As Long
    pwfx                                    As Long
    cbwfx                                   As Long
    pszTitle                                As Long
    szFormatTag                             As String * ACMFMTTAGDET_FORMATTAG_CHARS
    szFormat                                As String * ACMFMTDET_FORMAT_CHARS
    pszName                                 As Long
    cchName                                 As Long
    fdwEnum                                 As Long
    pwfxEnum                                As Long
    hInstance                               As Long
    pszTemplateName                         As Long
    lCustData                               As Long
    pfnHook                                 As Long
    btSpace(1023)                           As Byte ' seltsames Crashverhalten...
End Type

Private Type MMWAVEFORMATEX
    wFormatTag                              As Integer
    nChannels                               As Integer
    nSamplesPerSec                          As Long
    nAvgBytesPerSec                         As Long
    nBlockAlign                             As Integer
    wBitsPerSample                          As Integer
    cbSize                                  As Integer
End Type

Private Type WAVRIFF
    RIFF                                    As Long         ' "RIFF"
    hdrlen                                  As Long
    WAVE                                    As Long         ' "WAVE"
    fmt                                     As Long         ' "fmt "
    chnksize                                As Long
End Type

Private udtWFXIn                            As MMWAVEFORMATEX
Private btWfxOut()                          As Byte
Private lngWFXOutLen                        As Long
Private strFormatID                         As String
Private strFormatTag                        As String

Private btInp()                             As Byte
Private btOut()                             As Byte
Private lngInpLen                           As Long
Private lngOutLen                           As Long

Private udtStreamHdr                        As ACMSTREAMHEADER
Private hStream                             As HACMSTREAM

Private hFOut                               As hFile

Private blnWriteHeader                      As Boolean

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub Class_Initialize()
    Dim wfx As MMWAVEFORMATEX

    ReDim btWfxOut(WFXSize - 1) As Byte
    blnWriteHeader = True

    wfx = CreateWFX(44100, 2, 16)

    SetFormat VarPtr(wfx), Len(wfx), "44.1 kHz 16 Bit Stereo", "PCM"

    hFOut.handle = INVALID_HANDLE
End Sub

Private Sub Class_Terminate()
    EncoderClose
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Public Property Get WriteHeader() As Boolean
    WriteHeader = blnWriteHeader
End Property

Public Property Let WriteHeader(ByVal bln As Boolean)
    If hFOut.handle = INVALID_HANDLE Then
        blnWriteHeader = bln
    Else
        Err.Raise 90, , "Encoder luft bereits!"
    End If
End Property

Public Property Get FormatTag() As String
    FormatTag = strFormatTag
End Property

Public Property Get FormatID() As String
    FormatID = strFormatID
End Property

Public Sub SetPCMFormat( _
    ByVal Samplerate As Long, _
    ByVal Channels As Integer, _
    Optional ByVal FormatID As String, _
    Optional ByVal FormatTag As String _
)

    Dim wfx As MMWAVEFORMATEX

    wfx = CreateWFX(Samplerate, Channels, 16)

    If FormatID = "" Then
        With wfx
            strFormatID = Round(.nSamplesPerSec / 1000, 1) & " kHz " & _
                          .wBitsPerSample & " Bit " & _
                          IIf(.nChannels = 2, "stereo", "mono")
        End With
    End If

    If FormatTag = "" Then
        FormatTag = "PCM"
    End If

    SetFormat VarPtr(wfx), Len(wfx), _
              strFormatID, FormatTag
End Sub

Public Sub SetFormat( _
    ByVal wfx_ptr As Long, _
    ByVal wfx_len As Long, _
    Optional FormatID As String, _
    Optional FormatTag As String _
)

    If 0 = IsBadReadPtr(ByVal wfx_ptr, wfx_len) Then
        If wfx_len > UBound(btWfxOut) + 1 Then
            ReDim btWfxOut(wfx_len - 1) As Byte
        End If
        CpyMem btWfxOut(0), ByVal wfx_ptr, wfx_len

        lngWFXOutLen = wfx_len

        strFormatID = FormatID
        strFormatTag = FormatTag
    End If
End Sub

Public Function SelectFormat( _
    ByVal Samplerate As Long, _
    ByVal Channels As Integer, _
    Optional ByVal hwndOwner As Long, _
    Optional ByVal Title As String = "WAV Format" _
) As SND_RESULT

    Dim btTitle()   As Byte
    Dim btWFX()     As Byte
    Dim wfx         As MMWAVEFORMATEX
    Dim wfxinp      As MMWAVEFORMATEX
    Dim udtFmtCh    As ACMFORMATCHOOSEA

    ReDim btWFX(WFXSize - 1) As Byte

    btTitle = StrConv(Title & Chr$(0), vbFromUnicode)

    With wfxinp
        .nSamplesPerSec = Samplerate
        .nChannels = Channels
        .wBitsPerSample = 16
        .wFormatTag = WAVE_FORMAT_PCM
        .nBlockAlign = .nChannels * (.wBitsPerSample / 8)
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    End With

    CpyMem btWFX(0), wfxinp, Len(wfxinp)

    With udtFmtCh
        .cbStruct = LenB(udtFmtCh)
        .hwndOwner = hwndOwner
        .pwfx = VarPtr(btWFX(0))
        .cbwfx = WFXSize
        .pwfxEnum = VarPtr(wfxinp)
        .fdwEnum = ACM_FORMATENUMF_CONVERT
        .pszTitle = VarPtr(btTitle(0))
    End With

    If acmFormatChoose(udtFmtCh) = 0 Then
        btWfxOut = btWFX
        CpyMem wfx, btWFX(0), Len(wfx)
        lngWFXOutLen = CLng(18) + CLng(wfx.cbSize)

        strFormatID = RemNullChars(udtFmtCh.szFormat)
        strFormatTag = RemNullChars(udtFmtCh.szFormatTag)

        SelectFormat = SND_ERR_SUCCESS
    Else
        SelectFormat = SND_ERR_UNKNOWN
    End If
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Public Property Get Description() As String
    Description = "ACM WAV Encoder"
End Property

Public Property Get Extension() As String
    Extension = "wav"
End Property

Public Function EncoderClose() As SND_RESULT
    If hFOut.handle = INVALID_HANDLE Then
        EncoderClose = SND_ERR_INVALID_OUTPUT
    Else
        ' ACM Flush
        udtStreamHdr.cbSrcLength = 0
        acmStreamConvert hStream, udtStreamHdr, ACM_STREAMCONVERTF_END
        udtStreamHdr.cbSrcLength = lngInpLen

        FileWrite hFOut, udtStreamHdr.pbDst, udtStreamHdr.cbDstLengthUsed
        If blnWriteHeader Then WriteWAVHdr

        acmStreamUnprepareHeader hStream, udtStreamHdr, 0
        acmStreamClose hStream, 0
        hStream = INVALID_STREAM_HANDLE

        FileClose hFOut

        EncoderClose = SND_ERR_SUCCESS
    End If
End Function

Public Function Encode(ByVal buffer_ptr As Long, ByVal buffer_len As Long, buffer_used As Long) As SND_RESULT
    Dim lngRet      As Long
    Dim lngWritten  As Long

    If buffer_len > lngInpLen Then
        Encode = SND_ERR_TOO_BIG
        Exit Function
    End If

    If 0 = IsBadReadPtr(ByVal buffer_ptr, buffer_len) Then
        CpyMem btInp(0), ByVal buffer_ptr, buffer_len
    End If

    udtStreamHdr.cbSrcLength = buffer_len

    lngRet = acmStreamConvert(hStream, _
                              udtStreamHdr, _
                              ACM_STREAMCONVERTF_BLOCKALIGN)

    If lngRet <> 0 Then
        If udtStreamHdr.cbSrcLengthUsed = 0 Then
            Encode = SND_ERR_NEED_MORE
        Else
            Encode = SND_ERR_SUCCESS
        End If
    Else
        lngWritten = FileWrite(hFOut, _
                               udtStreamHdr.pbDst, _
                               udtStreamHdr.cbDstLengthUsed)

        If lngWritten = udtStreamHdr.cbDstLengthUsed Then
            Encode = SND_ERR_SUCCESS
        Else
            Encode = SND_ERR_WRITE_ERROR
        End If
    End If

    buffer_used = udtStreamHdr.cbSrcLengthUsed
End Function

Public Function EncoderInit(ByVal Samplerate As Long, ByVal Channels As Integer, ByVal output As String) As SND_RESULT
    Dim lngRet  As Long
    Dim btHdr() As Byte

    ' vorsichtshalber
    EncoderClose

    If Samplerate < 1 Or Channels < 1 Then
        EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    udtWFXIn = CreateWFX(Samplerate, Channels, 16)

    ' ACM Konvertierungsstream erstellen
    lngRet = acmStreamOpen(hStream, 0, udtWFXIn, btWfxOut(0), 0, 0, 0, 0)

    If lngRet <> 0 Then
        EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    lngInpLen = udtWFXIn.nAvgBytesPerSec

    ' bentigte Input Buffer Gre fr
    ' gewollte Output Buffer Gre
    lngRet = acmStreamSize(hStream, lngInpLen, lngOutLen, ACM_STREAMSIZEF_SOURCE)

    If lngRet <> 0 Then
        EncoderInit = SND_ERR_INVALID_PARAM
        acmStreamClose hStream, 0
        Exit Function
    End If

    ReDim btInp(lngInpLen - 1) As Byte
    ReDim btOut(lngOutLen - 1) As Byte

    With udtStreamHdr
        .cbStruct = Len(udtStreamHdr)
        .cbDstLength = lngOutLen
        .cbSrcLength = lngInpLen
        .pbDst = VarPtr(btOut(0))
        .pbSrc = VarPtr(btInp(0))
    End With

    lngRet = acmStreamPrepareHeader(hStream, udtStreamHdr, 0)

    If lngRet <> 0 Then
        EncoderInit = SND_ERR_INVALID_PARAM
        acmStreamClose hStream, 0
        Exit Function
    End If

    hFOut = FileOpen(output, _
                     GENERIC_WRITE, , _
                     CREATE_ALWAYS)

    If hFOut.handle = INVALID_HANDLE Then
        EncoderInit = SND_ERR_INVALID_OUTPUT
        Exit Function
    End If

    If blnWriteHeader Then
        ' Platz fr WAV Header (wird aufgrund unbekannter
        ' Datenmenge erst am Schluss geschrieben)
        ReDim btHdr(20 + lngWFXOutLen + 4 * 2 - 1) As Byte
        FileWrite hFOut, VarPtr(btHdr(0)), UBound(btHdr) + 1
    End If

    EncoderInit = SND_ERR_SUCCESS
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Function CreateWFX(sr As Long, chs As Integer, bps As Integer) As MMWAVEFORMATEX
    With CreateWFX
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = chs
        .nSamplesPerSec = sr
        .wBitsPerSample = bps
        .nBlockAlign = chs * (bps / 8)
        .nAvgBytesPerSec = sr * .nBlockAlign
    End With
End Function

Private Function RemNullChars(ByVal strString As String) As String
    If InStr(strString, Chr$(0)) > 0 Then
        RemNullChars = Left$(strString, InStr(strString, Chr$(0)) - 1)
    Else
        RemNullChars = strString
    End If
End Function

Private Sub WriteWAVHdr()
    Dim udtHdr      As WAVRIFF
    Dim lngDataID   As Long
    Dim lngData     As Long

    With udtHdr
        .RIFF = WAV_RIFF
        .WAVE = WAV_WAVE
        .fmt = WAV_FMT
        .hdrlen = FileLength(hFOut) - 8
        .chnksize = lngWFXOutLen
    End With

    FileSeek hFOut, 0, FILE_BEGIN
    FileWrite hFOut, VarPtr(udtHdr), Len(udtHdr)

    FileWrite hFOut, VarPtr(btWfxOut(0)), lngWFXOutLen

    lngDataID = WAV_DATA
    FileWrite hFOut, VarPtr(lngDataID), 4

    lngData = FileLength(hFOut) - (FilePosition(hFOut) + 4)
    FileWrite hFOut, VarPtr(lngData), 4
End Sub

' //////////////////////////////////////
' ////// API File Handling
' //////////////////////////////////////

Private Function IsValidFile(ByVal strFile As String) As Boolean
    Dim hInp    As hFile

    hInp = FileOpen(strFile, GENERIC_READ, FILE_SHARE_READ)
    IsValidFile = hInp.handle <> INVALID_HANDLE
    FileClose hInp
End Function

Private Function FileOpen( _
    ByVal strFile As String, _
    Optional access As FILE_ACCESS_RIGHTS = GENERIC_READ Or GENERIC_WRITE, _
    Optional share As FILE_SHARE_RIGHTS = FILE_SHARE_READ Or FILE_SHARE_WRITE, _
    Optional method As FILE_OPEN_METHOD = OPEN_EXISTING _
) As hFile

    FileOpen.handle = CreateFile(strFile, access, share, ByVal 0&, method, 0, 0)

    FileOpen.path = strFile
End Function

Private Sub FileClose(filehandle As hFile)
    CloseHandle filehandle.handle
    filehandle.handle = INVALID_HANDLE
    filehandle.path = vbNullString
End Sub

Private Function FileRead(filehandle As hFile, ByVal ptr As Long, ByVal Bytes As Long) As Long
    Dim dwRead  As Long
    Dim lngRet  As Long

    If filehandle.handle = INVALID_HANDLE Then
        Exit Function
    End If

    lngRet = ReadFile(filehandle.handle, ByVal ptr, Bytes, dwRead, 0&)

    If lngRet = 1 Then
        FileRead = dwRead
    Else
        FileRead = -1
    End If
End Function

Private Function FileWrite(filehandle As hFile, ByVal ptr As Long, ByVal Bytes As Long) As Long
    Dim dwWritten   As Long
    Dim lngRet      As Long

    If filehandle.handle = INVALID_HANDLE Then
        Exit Function
    End If

    lngRet = WriteFile(filehandle.handle, ByVal ptr, Bytes, dwWritten, 0&)

    If lngRet = 1 Then
        FileWrite = dwWritten
    Else
        FileWrite = -1
    End If
End Function

Private Function FileSeek(filehandle As hFile, ByVal Bytes As Long, ByVal method As SEEK_METHOD) As Long
    FileSeek = SetFilePointer(filehandle.handle, Bytes, 0, method)
End Function

Private Function FilePosition(filehandle As hFile) As Long
    FilePosition = FileSeek(filehandle, 0, FILE_CURRENT)
End Function

Private Function FileLength(filehandle As hFile) As Long
    FileLength = GetFileSize(filehandle.handle, 0)
End Function

Private Function FileEnd(filehandle As hFile) As Boolean
    FileEnd = FilePosition(filehandle) >= FileLength(filehandle)
End Function
